=== debian/watch ===
version=4
opts=mode=git,dversionmangle=auto,repacksuffix=+ds \
https://github.com/biojppm/rapidyaml.git \
refs/tags/v(\d.*)

opts="component=extcmake,mode=git,pretty=%cd.%h" \
https://github.com/biojppm/cmake.git \
HEAD ignore uupdate
