=== debian/changelog ===
rapidyaml (0.9.0+ds-3) unstable; urgency=medium

  * Adopt package (Closes: #1104863)
  * Bump Standards-Version to 4.7.2; no changes needed
  * debian/control
    - List dependencies one per line

 -- Gabriel Barrantes <gabriel.barrantes.dev@outlook.com>  Wed, 25 Jun 2025 16:19:03 -0600

rapidyaml (0.9.0+ds-2) unstable; urgency=medium

  * Prevent using git.

 -- Bastian Germann <bage@debian.org>  Wed, 07 May 2025 17:03:16 +0200

rapidyaml (0.9.0+ds-1) unstable; urgency=medium

  * Initial release. Closes: #1003397

 -- Bastian Germann <bage@debian.org>  Tue, 06 May 2025 20:11:47 +0200
